//Calcul de l'heure solaire locale vraie, affichage LCD I2C
//Calcul équation du temps avec JJ
//Programmation du 11-09-2019 - M. Druon
#include <Wire.h>
#include <TinyGPS++.h>
#include <LiquidCrystal_I2C.h>
TinyGPSPlus gps;
LiquidCrystal_I2C lcd(0x27,20,4);
float Long; float HSmoy; float Md; float Mr; float Ld; float Lr; float Eqh; float Eqmin; float pi;
float HSVh; float mmd; float Tempsh; float JJ; float MJJ; float J2000; float CM; float CL;
float TSS1; float TSS2; float TSS3; float TSS4; float TSS; float TSJ; float HSiJ; float HSih;
int Jour; int Mois; int Heu; int Min; int Sec; int NJ; int I; int An;
int hh; int mm; int ss; int Eqm; int Eqs;
int C; int B; int VAL; int Col; int Lig;
                  
void setup() {
  lcd.init();
  lcd.backlight();
  Serial2.begin(9600);
  pi = 4*atan(1);
  J2000=2451545;
  lcd.setCursor (0,0); lcd.print ("Heures: TU=");
  lcd.setCursor (14,0); lcd.print (":"); lcd.setCursor (17,0); lcd.print(":");
  lcd.setCursor (0,1); lcd.print ("        TS=");
  lcd.setCursor (14,1); lcd.print (":"); lcd.setCursor (17,1); lcd.print(":");
  lcd.setCursor (0,2); lcd.print ("   solaire=");
  lcd.setCursor (14,2); lcd.print (":"); lcd.setCursor (17,2); lcd.print(":");
  lcd.setCursor (0,3); lcd.print ("Eq.Temps= ");
  lcd.setCursor (13,3); lcd.print ("min "); lcd.setCursor (19,3); lcd.print ("s");
  }

void loop() {
Attente(50);
if (gps.charsProcessed() < 10) {
  Serial.println ("PROBLEME");
  }
  else if ((gps.charsProcessed() > 10) && (gps.altitude.isUpdated()))
  {
//Obtention des données GPS
  Long=gps.location.lng();
    Jour=gps.date.day(); Mois=gps.date.month(); An=gps.date.year();
    Heu=gps.time.hour(); Min=gps.time.minute(); Sec=gps.time.second();
  
//Affichage TU
  Col=12; Lig=0; VAL=Heu;
  Affichage_VAL ();
  Col=15; Lig=0; VAL=Min;
  Affichage_VAL ();
  Col=18; Lig=0; VAL=Sec;
  Affichage_VAL ();
   
//Calculdu Jour julien
  JJulien ();
   
//Calcul équation du temps
  Equation_Temps ();
  Eqh=Eqmin/60;
  Eqm=int(Eqmin); Eqs=int((Eqmin-Eqm)*60);
  
  
//Affichage Equation du Temps
  lcd.setCursor (10,3);
  if (Eqm>0) {
    lcd.print ("+");}
    else {
      lcd.print ("-");}
  Col=11; Lig=3; VAL=abs(Eqm); Affichage_VAL ();  
  Col=17; Lig=3; VAL=abs(Eqs); Affichage_VAL ();    
  
//Calcul de l'heure solaire locale vraie
  HSmoy=Heu+Min/60.0+Sec/3600.0+Long/15;
  HSVh=HSmoy-Eqh;
  Tempsh=HSVh;
  Affichage_HHMMSS ();
  
//Affichage Heure solaire locale vraie
  Col=12; Lig=2; VAL=hh; Affichage_VAL ();
  Col=15; Lig=2; VAL=mm; Affichage_VAL ();
  Col=18; Lig=2; VAL=ss; Affichage_VAL ();
    
//Calcul de l'heure sidérale
   Heure_Sid ();
   Tempsh=HSih;
   
//Affichage de l'heure sidérale
   Affichage_HHMMSS ();
   Col=12; Lig=1; VAL=hh; Affichage_VAL ();
   Col=15; Lig=1; VAL=mm; Affichage_VAL ();
   Col=18; Lig=1; VAL=ss; Affichage_VAL ();
 }}

static void Attente(unsigned long ms) {
  unsigned long TempsDepart = millis();
  do {
      while (Serial2.available())
    gps.encode(Serial2.read());
  }
  while (millis()-TempsDepart <ms);
  }      
     
void Equation_Temps () {
    MJJ=0.9856*(JJ-J2000+1);
    Md=357.04+MJJ;
    Mr=pi*Md/180;
    CM=1.9148*sin(Mr)+0.02*sin(2*Mr)+0.0003*sin(3*Mr);
    Ld=282.93+Md+CM;
    Lr=pi*Ld/180;
    CL=-2.468*sin(2*Lr)+0.053*sin(4*Lr)-0.0014*sin(6*Lr);   
    Eqmin=4*(CM+CL);
    }
    
void Affichage_HHMMSS () {
      hh=int(Tempsh);
      mmd=(Tempsh-hh)*60;
      mm=int (mmd);
      ss=int((mmd-mm)*60);
      }
      
void JJulien (){
  if (Mois<3) {
    Mois=Mois+12;
    An=An-1; }
    C=int(An/100);
    B=2+int(An/400);
    JJ=int(365.25*An)+int(30.6001*(Mois+1))+Jour-C+B+1720995;
     }
    
void Heure_Sid () {
  TSS1=24110.5484;
  TSS2=8640184.812866*(JJ-0.5-J2000)/36525;
  TSS3=1.002737909*(Heu*3600+Min*60+Sec);
  TSS4=Long*240;
  TSS=TSS1+TSS2+TSS3+TSS4;
  TSJ=TSS/86400;
  HSiJ=TSJ-int(TSJ);
  HSih=HSiJ*24;
  }
  
void Affichage_VAL () {
  if (VAL<10) {
    lcd.setCursor (Col, Lig); lcd.print ("0");
    lcd.setCursor (Col+1,Lig); lcd.print (VAL); }
  else {
    lcd.setCursor (Col, Lig); lcd.print (VAL);}
    }
    
    
