//Calcul de l'heure solaire locale vraie, affichage LCD I2C
//Calcul équation du temps avec JJ
//Programmation du 11-09-2019 M. DRUON - Modifié avril 2020 M. COLLIN
#include <Wire.h>
#include <TinyGPS++.h>
#include <LiquidCrystal_I2C.h>
#include <math.h>

TinyGPSPlus gps;
LiquidCrystal_I2C lcd(0x27,20,4);

double rad; double pi;
float Long; float Lat; float HSmoy; float Md; float Mr; float Ld; float Lr; float Eqh; double Eqmin; 
float HSVh; float mmd; float Tempsh; double JJ; float MJJ; float J2000; float CM; float CL;
float TSS1; float TSS2; float TSS3; float TSS4; float TSS; float TSJ; float HSiJ; float HSih;
float Eqs10e; 

double TT; double epsilon; double yy; double EE; double MM; double LL; double FF;
double term1; double term2; double term3; double term4; double term5; double EQTEmpsRad; double EQTempsDeg;
double U; double U2; double U3; double U4; double U5; double U6; double U7; double U_8; double U9; double U10;
double tau;

int Jour; int Mois; int Heu; int Min; int Sec; int NJ; int I; int An;
int hh; int mm; int ss; int Eqm; int Eqs; int Eqsd; int Eqs100e;
int C; int B; int VAL; int Col; int Lig; 

unsigned long Duree; unsigned long TempsDepart;

// -------------------------------------
void setup() {//
  Serial.begin(9600); // ligne ajoutée
  Serial3.begin(9600); // Serial2 modifié en Serial3 car pb avec serial2 
  // (??? La broche Tx de la puce GPS est conenctée à la broche Rx3 de la carte Due. LA broche Rx du GPS n est pas utilisée ici)
  // constantes
  pi = 3.1415926535897932384626433837950288;  // 4*atan(1);
  rad = pi/180.0;
  J2000 = 2451545.0;// Jour Julien au 01/01/2000 à 12 h UT.
  // affichage texte fixe:
  lcd.init();
  lcd.backlight();
  //
  J2000=2451545;
  lcd.setCursor (0,0); lcd.print ("Heures: UT=");
  lcd.setCursor (14,0); lcd.print (":"); lcd.setCursor (17,0); lcd.print(":");
  lcd.setCursor (8,1); lcd.print ("TS=");
  lcd.setCursor (14,1); lcd.print (":"); lcd.setCursor (17,1); lcd.print(":");
  lcd.setCursor (3,2); lcd.print ("Solaire=");
  lcd.setCursor (14,2); lcd.print (":"); lcd.setCursor (17,2); lcd.print(":");
  lcd.setCursor (0,3); lcd.print ("Eq.Temps=");
  lcd.setCursor (13,3); lcd.print ("m "); 
  lcd.setCursor (17,3); lcd.print (".");  lcd.setCursor (19,3); lcd.print ("s");
}// fin setup
// -------------------------------------
// -------------------------------------
void loop() {//
Attente();
if (gps.charsProcessed() < 10) {// cette ligne avec le if a été décommentée pour être ajoutée.
  Serial.println ("PROBLEME");
  Serial.println(F("Aucune donnée GPS reçue. Vérifier la couverture GPS et les connexions"));
  }// // condition midifiée ligne ci-dessous
else if ((gps.charsProcessed() > 10) && (gps.location.isUpdated())) // && (gps.altitude.isUpdated())) 
  {//
//Obtention des données GPS
    Long=gps.location.lng();Lat=gps.location.lat();
    Jour=gps.date.day(); Mois=gps.date.month(); An=gps.date.year();
    Heu=gps.time.hour(); Min=gps.time.minute(); Sec=gps.time.second(); 
    //Centieme=gps.time.centisecond();
// --------------------------------------------  Affichage dans la console de sortie pour vérification des données 
  Serial.println("---------------"); 
  Serial.println("---------------"); 
 Serial.println("Latitude="); Serial.println(Lat,DEC);
 Serial.println("Longitude="); Serial.println(Long,DEC); 
  Serial.println("-----"); 
   Serial.println("Fraction de Jour FF= "); Serial.println(FF,DEC); 
   Serial.println("Jour Julien JJ= "); Serial.println(JJ,DEC); 
  Serial.println("------"); 
   Serial.println("Equation du Temps en heure = "); Serial.println(Eqh,DEC); 
   Serial.println("Equation du Temps en minutes = "); Serial.println(Eqmin,DEC); 
   Serial.println("En secondes = "); Serial.println((abs(Eqmin)-Eqm)*60,DEC); 
    Serial.println("Les 1/10 seconde retenues = "); Serial.println(Eqsd);  
  Serial.println("---------------"); 

// --------------------------------------------  
 
//Première LIGNE du LCD
//Affichage UT
  Col=12; Lig=0; VAL=Heu;
  Affichage_VAL ();
  Col=15; Lig=0; VAL=Min;
  Affichage_VAL ();
  Col=18; Lig=0; VAL=Sec;
  Affichage_VAL ();
   
// Calcul de la fraction de jour de l'heure, minutes, secondes du GPS:
  Fraction_Jour ();  // utile car à ajouter au Jour Julien à 0 h UT...

//Calcul du Jour julien
  JJulien ();
   
//Calcul équation du temps
  Equation_Temps ();
  // -- pour l'affichage
  Eqh=Eqmin/60; // négatif si Eqmin négatif donc attention aux test ulétérieurs (15/04/2020)
  Eqm=int(abs(Eqmin)); // minutes entières positives
  Eqs=int((abs(Eqmin)-Eqm)*60); // secondes entières positives
  // Les dixièmes de seconde de Eqmin :
  Eqs10e = ( (abs(Eqmin)-Eqm)*60 - Eqs )*10;
  // Partie entière des 100eme de seconde
  Eqs100e = int( abs((Eqs10e-int(Eqs10e))*10 ));
  
  // Pour faire un arrondi traditionnel.
  if(Eqs100e<5) { Eqsd = floor(Eqs10e); // partie entière par défaut 
    }//
    else { if(int(Eqs10e)>=9) { Eqsd = 0; Eqs = Eqs + 1; }// pour éviter de passer à 10 pour Eqsd
            else { Eqsd = ceil(Eqs10e); }// partie entière par excès (donc ajoute 1 à Eqs10e)
    }
  
// Quatrième LIGNE DU LCD
//Affichage Equation du Temps
lcd.setCursor (10,3);
  if (Eqmin>0) {// affichage du signe de l'équation du Temps..
    lcd.print ("+");}
    else {
      lcd.print ("-");}
  //
  Col=11; Lig=3; VAL=abs(Eqm); Affichage_VAL ();  // affichage des minutes
  Col=15; Lig=3; VAL=abs(Eqs); Affichage_VAL ();  // affichage des secondes  
  Col=18; Lig=3; lcd.setCursor(Col, Lig); lcd.print (int(Eqsd)); // affichage des dixièmes de seconde.

  
//Calcul de l'heure solaire locale vraie
  HSmoy=Heu+Min/60.0+Sec/3600.0+Long/15.0;
  HSVh=HSmoy-Eqh;
  Tempsh=HSVh;
  Affichage_HHMMSS ();
  
// Troisième LIGNE DU LCD
//Affichage Heure solaire locale vraie
  Col=12; Lig=2; VAL=hh; Affichage_VAL ();
  Col=15; Lig=2; VAL=mm; Affichage_VAL ();
  Col=18; Lig=2; VAL=ss; Affichage_VAL ();
    
//Calcul de l'heure sidérale
   Heure_Sid ();
   Tempsh=HSih;
   Affichage_HHMMSS ();
      
// Deuxième LIGNE DU LCD
//Affichage de l'heure sidérale
   Col=12; Lig=1; VAL=hh; Affichage_VAL ();
   Col=15; Lig=1; VAL=mm; Affichage_VAL ();
   Col=18; Lig=1; VAL=ss; Affichage_VAL ();
 
 }// fin else if
 }
 // ---- fin loop
// -------------------------------------

//static void Attente(unsigned long ms) {//
//  unsigned long TempsDepart = millis();
//  do {
//      while (Serial3.available())
//      gps.encode(Serial3.read());
//     }
//  while (millis()-TempsDepart <ms);
//  }
// lignes précédentes modifiées comme suit:
// Modification du void Attente() ...   
void Attente() {
  TempsDepart = millis();
  do   {
    while (Serial3.available())
    gps.encode(Serial3.read()); 
       }
    while (millis()-TempsDepart <Duree);
    }
// -------------------------
        
void Fraction_Jour () {// converti heure, minute, seconde en fraction de jour:
  FF  = ( Heu + (Min/60.0) + (Sec/3600.0) )/24.0;
}

// Jour Julien de la date avec fraction de Jour ...
void JJulien (){// l'année (An) est toujours supérieure à 1582,1015 ...
  if (Mois<3) {
    Mois=Mois+12;
    An=An-1; 
    }// fin if
    C=int(An/100);
    B=2+int(An/400);
    JJ=int(365.25*An) + int(30.6001*(Mois+1)) + (Jour + FF) + (B-C) + 1720994.5; // même formule que dans le MEEUS??? voir Meeus page 61 (7.1)...
}

// Fonction calcul / Ephémérides / ci-dessous
// Equation du temps à l'année, date, heure, minutes, secondes du GPS:
// --
void Equation_Temps () {// Modifié par D. Collin
  // Equation du Temps - Chapitre 18, page 183; page 147 ; page 163 de l'ouvrage (en anglais)  seconde éd. 1998 avec corrections du 10/08/2009 de Jean MEEUS.
  // Voir aussi M. Grasica, Cadran-Info n°40, octobre 2019, page 77 (qq erreurs typographiques dans la formule)
 
  // J2000 à 0 h TU puis ajout de la fraction de l'heure, minutes, secondes et centième de secondes GPS de la date JJ...
  TT=(JJ - J2000)/36525.0;
  // --
  U=TT/100.0; // pour le calcul de l'obliquité de l'écliptique - formule de J. Laskar - Meuus page 147 (22.3).
  U2=U*U;
  U3=U*U*U;
  U4=U*U*U*U;
  U5=U*U*U*U*U;
  U6=U*U*U*U*U*U;
  U7=U*U*U*U*U*U*U;
  U_8=U*U*U*U*U*U*U*U;  // U_8 car U8 est réservé en interne par le compilateur...
  U9=U*U*U*U*U*U*U*U*U;
  U10=U*U*U*U*U*U*U*U*U*U;
  // --
  tau = TT/10.0;  // pour le calcul de la longitude moyenne du Soleil - Meeus page 183, (28.2)
  // --
  epsilon = (23+26/60.0+21.448/3600.0) - 4680.927/3600.0*U - 1.55/3600.0*U2 + 1999.25/3600.0*U3 - 51.38/3600.0*U4 - 249.67/3600.0*U5 - 39.05/3600.0*U6 + 7.12/3600.0*U7 + 27.87/3600.0*U_8 + 5.79/3600.0*U9 + 2.45/3600.0*U10;
  EE = 0.0167086342 - 0.00004203654*TT - 0.000000126734*TT*TT - 0.00000000014*TT*TT*TT; // Excentricité de la Terre
  LL = 280.4664567 + 360007.6982779*tau + 0.03032028*(tau*tau) + (tau*tau*tau)/49931.0 - (tau*tau*tau*tau)/15300.0 - (tau*tau*tau*tau*tau)/2000000.0; // Longitude moyenne du Soleil
  MM = 357.52911 + 35999.05029*TT - 0.0001537*TT*TT; // Anomalie moyenne du Soleil. Meeus, page 163 (25.2)
  //
  yy=tan(epsilon/2*rad)*tan(epsilon/2*rad);// paramètre issue du développement en série
  //
  /*  Formules utilisées par M. Druon
  epsilon=23.4392911-0.01300417*TT-0.000000164*TT*TT;// Obliquité de l'écliptique en deg.
  yy=tan(epsilon/2*rad)*tan(epsilon/2*rad);// paramètre issue du développement en série
  EE=0.016708634-0.000042037*TT-0.0000001267*TT*TT;// Excentricité de l'orbite de la Terre
  MM=357.5291+35999.0503*TT-0.000154*TT*TT; // Anomalie moyenne du Soleil en deg.
  LL=280.4664567+36000.76982779*TT+0.000303202*TT*TT;//Longitude moyenne du Soleil en deg.
  */
  //
  term1=yy*sin(2*LL*rad);
  term2=2*EE*sin(MM*rad);
  term3=4*EE*yy*sin(MM*rad)*cos(2*LL*rad);
  term4=0.5*yy*yy*sin(4*LL*rad);
  term5=1.25*EE*EE*sin(2*MM*rad);
  //
  EQTEmpsRad = -term1 + term2 - term3 + term4 + term5; // convention de signe pour une Eq. Temps française. Meeus page 185 (28.3 changée de signe).
  EQTempsDeg = (EQTEmpsRad*180/pi);// Eq du Temps en degrés...
  Eqmin = (EQTempsDeg/15)*60;// on ramène en heure puis en minutes l'équation du temmps...
// --
}// fin void Eq. Temps.

void Heure_Sid () {// Attention = temps Sidéral MOYEN...
  TSS1=24110.5484;
  TSS2=8640184.812866*(JJ-J2000)/36525.0;
  TSS3=1.00273790935*(Heu*3600+Min*60+Sec);//2 décimales ajoutées
  TSS4=Long*240;
  TSS=TSS1+TSS2+TSS3+TSS4;
  TSJ=TSS/86400;
  HSiJ=TSJ-int(TSJ);
  HSih=HSiJ*24;
}

void Affichage_HHMMSS () {//
   hh=int(Tempsh);
   mmd=(Tempsh-hh)*60;
   mm=int (mmd);
   ss=int((mmd-mm)*60);
}
  
void Affichage_VAL () {//
  if (VAL<10) {
    lcd.setCursor (Col, Lig); lcd.print ("0");
    lcd.setCursor (Col+1,Lig); lcd.print (VAL);}
  else {
    lcd.setCursor (Col, Lig); lcd.print (VAL);}
}
// -- fin
